<html lang="en">
<head>
<title>Semantic Internals - Semantic Manual</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Semantic Manual">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="prev" href="Semantic-manuals.html#Semantic-manuals" title="Semantic manuals">
<link rel="next" href="Glossary.html#Glossary" title="Glossary">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<!--
This manual documents Semantic, a new intrastructure for parser
based text analysis for Emacs.

Copyright (C) 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2007 Eric M. Ludlam
Copyright (C) 2001, 2002, 2003, 2005 David Ponce
Copyright (C) 2002, 2003 Richard Y. Kim

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU Free Documentation License,
     Version 1.1 or any later version published by the Free Software
     Foundation; with the Invariant Sections being list their titles,
     with the Front-Cover Texts being list, and with the Back-Cover
     Texts being list.  A copy of the license is included in the
     section entitled ``GNU Free Documentation License''.
-->
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Semantic-Internals"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Glossary.html#Glossary">Glossary</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Semantic-manuals.html#Semantic-manuals">Semantic manuals</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="index.html#Top">Top</a>
<hr>
</div>

<h2 class="chapter">4 Semantic Internals</h2>

<p>This chapter explains the internals of <i>semantic</i>. 
This information would not be needed by neither application developers
nor grammar developers.

<p>It would be useful mostly for the hackers who would like to learn
more about how <i>semantic</i> works.

<h3 class="section">4.1 Semanticdb</h3>

<p><acronym>Semanticdb</acronym> complexity is certainly an issue.  It is a rather
hairy problem to try and solve.

<p>This is just an overview really.  The basic organization is this:

     <dl>
<dt><samp><span class="file">semanticdb.el</span></samp><dd>Defines a <dfn>database</dfn> and a <dfn>table</dfn> base class.  You can
instantiate these classes, and use them, but they are not persistent.

     <p>This file also provides support for <code>semanticdb-minor-mode</code>,
which automatically associates files with tables in databases so that
tags are <em>saved</em> while a buffer is not in memory.

     <p>Lastly, it has that <dfn>root</dfn> stuff in it.  Basically, it is a system
by which a file can be associated with the root of a project, so if
you have a tree of directories and source files, it can find the root,
and allow a tag-search to span all available databases in that
directory hierarchy.

     <br><dt><samp><span class="file">semanticdb-file.el</span></samp><dd>Subclass the base class database so that it can be saved to disk. 
Implements all the hooks needed to unbind/rebind tags to a buffer
while writing them to a file.  Overrides various methods as necessary.

     <br><dt><samp><span class="file">semanticdb-system.el</span></samp><dd>Subclass <code>semanticdb-file</code>.  Supports creating a <acronym>DB</acronym> in
a directory you do not have write-access to, and saving the cache in
your home directory.  Also implements a <acronym>C</acronym>/<acronym>C++</acronym>
subclass which can be used for caching <samp><span class="file">/usr/include</span></samp>.  (A rather
slow process.)

     <br><dt><samp><span class="file">semanticdb-el.el</span></samp><dd>Implements a different kind of <dfn>system</dfn> database that uses Emacs
internals to perform queries.  Sadly, this shows a problem of
nomenclature since it is not a <code>semanticdb-system-database</code>
(which saves to a file), but database with no file component that
queries system tags in a different way.

     <br><dt><samp><span class="file">semanticdb-find.el</span></samp><dd>Infrastructure for searching groups <i>semantic</i> databases, and dealing
with the search results format. 
</dl>

<p>New things partly written, or to be written someday.

     <dl>
<dt><samp><span class="file">semanticdb-postgres.el</span></samp><dd>Any <acronym>DB</acronym> would do, <acronym>MySQL</acronym> would be fine.  Basically write
tags into a relational database, and provide searching facilities. 
This is probably the only way to allow fast look-ups in humongous
source areas.  Another possibility would be something like what
<acronym>Cscope</acronym> does.

     <br><dt><samp><span class="file">semanticdb-java.el</span></samp><dd>A system database for <acronym>Java</acronym> that uses <acronym>JDEE</acronym>
<acronym>BeanShell</acronym> queries.

     <br><dt><samp><span class="file">semanticdb-obj.el</span></samp><dd>A system database that uses command line tools to rip symbols out of
<samp><span class="file">.so</span></samp>, or <samp><span class="file">.a</span></samp>, or <samp><span class="file">.o</span></samp> files, and translates into
tags.

     <br><dt><samp><span class="file">semanticdb-javascript.el</span></samp><dd>A recent notion that somehow knows all those built-ins
<acronym>JavaScript</acronym> has. 
</dl>

<!-- LocalWords:  Cscope JDEE BeanShell JavaScript MySQL Semanticdb -->
</body></html>

